package com.casic.dcms.mvp.model;

import com.casic.dcms.bean.DeptTreeBean;
import com.casic.dcms.utils.retrofit.RetrofitServiceManager;

import rx.Observable;
import rx.Observer;
import rx.Subscription;
import rx.android.schedulers.AndroidSchedulers;
import rx.schedulers.Schedulers;

/**
 * @author : Pengxh
 * @time : 2021/4/15 12:35
 * @email : 290677893@qq.com
 **/
public class DeptTreeModelImpl implements IDeptTreeModel {

    private OnGetDeptTreeListener listener;

    public DeptTreeModelImpl(OnGetDeptTreeListener changedListener) {
        this.listener = changedListener;
    }

    /**
     * 数据回调接口
     */
    public interface OnGetDeptTreeListener {
        void onSuccess(DeptTreeBean resultBean);

        void onFailure(Throwable throwable);
    }

    @Override
    public Subscription sendRetrofitRequest(String pid) {
        Observable<DeptTreeBean> observable = RetrofitServiceManager.getDeptTreeResult(pid);
        return observable.subscribeOn(Schedulers.io()).observeOn(AndroidSchedulers.mainThread()).subscribe(new Observer<DeptTreeBean>() {
            @Override
            public void onCompleted() {

            }

            @Override
            public void onError(Throwable e) {
                if (e.getCause() != null) {
                    listener.onFailure(e);
                }
            }

            @Override
            public void onNext(DeptTreeBean resultBean) {
                if (resultBean != null) {
                    listener.onSuccess(resultBean);
                }
            }
        });
    }
}
